﻿using System;
using System.Drawing;

using Foundation;
using UIKit;
using System.IO;
using CoreFoundation;

namespace WebViewTest
{
    public partial class WebViewTestViewController : UIViewController
    {
        static bool UserInterfaceIdiomIsPhone
        {
            get { return UIDevice.CurrentDevice.UserInterfaceIdiom == UIUserInterfaceIdiom.Phone; }
        }

        public WebViewTestViewController(IntPtr handle)
            : base(handle)
        {
        }

        public override void DidReceiveMemoryWarning()
        {
            // Releases the view if it doesn't have a superview.
            base.DidReceiveMemoryWarning();
            
            // Release any cached data, images, etc that aren't in use.
        }


        private const int NSEC_PER_USEC = 1000; // Number of nano seconds in a microsecond
        public override void PresentViewController(UIViewController viewControllerToPresent, bool animated, Action completionHandler)
        {
            DispatchQueue.DefaultGlobalQueue.DispatchAfter(new DispatchTime(DispatchTime.Now, NSEC_PER_USEC), () =>
                {
                    base.PresentViewController(viewControllerToPresent, animated, completionHandler);
                });
        }

        //        //THIS IS ADDED TO RESOVE AN iOS8 BUG WHERE NATIVE UI MODALS ON A UIWEBVIEW CAN CRASH THE APP
        //        private const int NSEC_PER_USEC = 1000; // Number of nano seconds in a microsecond
        //        public override void PresentViewController(UIViewController viewControllerToPresent, bool animated, Action completionHandler)
        //        {
        //            DispatchQueue.DefaultGlobalQueue.DispatchAfter(new DispatchTime(DispatchTime.Now, NSEC_PER_USEC), () => {
        //                base.PresentViewController(viewControllerToPresent, animated, completionHandler);
        //            });
        //        }

        #region View lifecycle

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();

            UIWebView webView;
            webView = new UIWebView (View.Bounds);
            View.AddSubview(webView);

            string fileName = "Test.html"; // remember case-sensitive
            string localHtmlUrl = Path.Combine (NSBundle.MainBundle.BundlePath, fileName);
            webView.LoadRequest(new NSUrlRequest(new NSUrl(localHtmlUrl, false)));
            webView.ScalesPageToFit = false;
            // Perform any additional setup after loading the view, typically from a nib.
        }

        /*public override void ViewWillAppear(bool animated)
        {
            base.ViewWillAppear(animated);
        }

        public override void ViewDidAppear(bool animated)
        {
            base.ViewDidAppear(animated);
        }

        public override void ViewWillDisappear(bool animated)
        {
            base.ViewWillDisappear(animated);
        }

        public override void ViewDidDisappear(bool animated)
        {
            base.ViewDidDisappear(animated);
        }
        */

        #endregion

        public override void DismissViewController(bool animated, Action completionHandler)
        {

        }

       /* [Export("webView:shouldStartLoadWithRequest:navigationType:")]
        public virtual bool ShouldStartLoad (UIWebView webView, NSUrlRequest request, UIWebViewNavigationType navigationType)
        {
            return false;
        }
        */

    }
}

